<?php
/*
	Spacechem save format
	Annotation	: component_id output_id expanded x y annotation
	Component	: rowid level_id type x y name active_layers visible_layers locked_layers
	Level		: id passed mastered cycles symbols reactors best_cycles best_symbols best_reactors
	Local		: key value
	Member		: rowid component_id type arrow_dir choice layer x y element_type element
	Pipe		: component_id output_id x y
	ResearchNet	: level_id when_created definition
	Undo		: level_id id log
	UndoPtr		: level_id ptr 
	
	http://spacechem.net/solution/nothing-works/1849
	http://spacechem.net/solution/no-need-for-introductions/8057
	
	http://spacechem.net/solution/more-than-machine/6933
	http://spacechem.net/solution/don%27t-fear-the-reaper/15178
*/

require_once("db.inc.php");
require_once("utils.inc.php");
require_once("spacechem.class.php");



$fpath= "000.user";
$key= mysql_real_escape_string(aget('key', $_GET, "4-6"));

$res= mysql_query("SELECT * FROM `maps` WHERE `key`='$key'") or die(mysql_error());
$map= mysql_fetch_assoc($res);

htmlBegin(array(
			'title' => "{$map['key']} &ndash; {$map['name']}", 
			'css' => array('spacechem.css')
));

main($fpath, $key);

htmlEnd();

// -----------------------------------------------------------------------------
// FUNCTIONS
// -----------------------------------------------------------------------------

function main($fpath, $key)
{
	$ldb= new SQLite3($fpath, SQLITE3_OPEN_READONLY);
	
	$scm= new spaceChemMap();
	
	if($scm->load($ldb, $key))
	{
		$lut= array(
			'3-5'	=> "http://spacechem.net/solution/nothing-works/1849",
			'4-6'	=> "http://spacechem.net/solution/no-need-for-introductions/8057", 
			'6-5'	=> "http://spacechem.net/solution/more-than-machine/6933",
			'7-6'	=> "http://spacechem.net/solution/don%27t-fear-the-reaper/15178",
		);
		
		$map= $scm->map();
		$url= (isset($lut[$key]) ? $lut[$key] : "");
		
		echo htmlTable($scm->buildings());
		echo <<<DOC
<h2>
  <a href="$url">
    {$map['key']} &ndash; {$map['name']}
  </a>
</h2>
DOC;
		echo $scm->render();
	}

	
	//test_scMap($ldb,$key);

	//scGetMemberTypes($ldb);
	//scGetReactorTypes($ldb);
	
	//scGetSizes($ldb);
	//scDump($ldb, false);
}


function scGetTables($ldb)
{
	$res= $ldb->query("SELECT name FROM sqlite_master WHERE type='table' ORDER BY name;");

	$tables= array();
	while ($row = $res->fetchArray())
		$tables[$row['name']]= array();
	
	foreach($tables as $k => $v)
	{
		$res= $ldb->query("PRAGMA table_info('$k');");
		while($row = $res->fetchArray(SQLITE3_ASSOC))
			$tables[$k][]= $row['name'];
	}
	
	return $tables;
}

function scGetSizes($ldb)
{
	$tables= scGetTables($ldb);
	$content= "";
	foreach($tables as $k => $v)
	{
		$size= $ldb->querySingle("SELECT count(*) FROM `$k`;");
		$content .= "<tr><th>$k</th><td>$size</td></tr>\n";
	}
	echo <<<DOC
<table>
$content
</table>
DOC;
}

function scDump($ldb, $undo=true)
{
	$tables= scGetTables($ldb);
	
	if(!$undo)
		unset($tables['Undo']);
	foreach($tables as $tk => $tv)
	{
		$res= $ldb->query("SELECT * FROM `$tk`;");
		$content= array();
		
		$header= "";
		foreach($tv as $v)
			$header .= "  <th>$v</th>";
		
		while($row = $res->fetchArray(SQLITE3_ASSOC))
		{
			$line= "";
			foreach($row as $rk => $rv)
				$line .= "  <td>$rv</td>";
			$content[]= "<tr> $line </tr>\n";
		}
		
		$content= implode($content);

		echo <<<DOC
<table>
<h2>$tk</h2>
<tr> $header </tr>
$content
</table>
DOC;
	}
}

function scGetReactorTypes($ldb)
{
	$res= $ldb->query("SELECT * FROM `Component` GROUP BY `type` ORDER BY `type`;");
	$a= array();
	while($row = $res->fetchArray(SQLITE3_ASSOC))
	{
		$sql= "SELECT `key`, `type` AS type2 FROM `maps` WHERE id2 = '${row['level_id']}';";
		$res2= mysql_query($sql);
		if(mysql_num_rows($res2) > 0)
			$row2= mysql_fetch_assoc($res2);
		else
			$row2= array('key' => "", 'type2' => "");
			
		$a[]= array_merge($row2, $row);
	}
		
	echo htmlTable($a);
}


function scGetMemberTypes($ldb)
{
	$res= $ldb->query("SELECT `type`,`choice` FROM `Member` GROUP BY `type`,`choice` ORDER BY `type`;");
	$a= array();
	while($row = $res->fetchArray(SQLITE3_ASSOC))
		$a[]= $row;
		
	echo htmlTable($a);
}

// Get all results from a sqlite query as a matrix.
function ldbQueryAll($ldb, $query)
{
	$res= $ldb->query($query);
	$a= array();
	while($row = $res->fetchArray(SQLITE3_ASSOC))
		$a[]= $row;
		
	return $a;
}

?>
